﻿
init python:
    class linger_contact:
        def __init__(self, name, info, images, gender = "Woman", interests = "Both", chance = 100):
            self.name = name
            self.info = info
            self.images = images
            self.gender = gender
            self.interests = interests
            self.chance = chance

    class linger_class:
        def __init__(self, dating_pool, shuffle_pool = True):
            self.dating_pool = dating_pool
            if shuffle_pool:
                random.shuffle(self.dating_pool)
            self.liked = []
            self.super_likes = []
            self.disliked = []
            self.current = None
            self.stage = "start"
            self.gender = None
            self.interests = None
            self.more_info = None
            self.image_view = None

        def pick(self):
            if self.current:
                return
            if len(self.dating_pool) == 0:
                self.stage = "no dates"
                return
            date = self.dating_pool.pop()
            if self.interests in ["Both", date.gender]:
                if date.interests in ["Both", self.gender]:
                    self.current = date
                    return
            self.pick()

        def like(self):
            if not self.current in self.liked:
                self.liked.append(self.current)
            self.current = None
        def super_like(self):
            if not self.current in self.super_likes:
                self.super_likes.append(self.current)
            self.current = None
        def dislike(self):
            if not self.current in self.disliked:
                self.disliked.append(self.current)
            self.current = None

        def change_stage(self, stage):
            self.stage = stage
        def set_my_gender(self, gender):
            self.gender = gender
            self.stage = "my interest"
        def set_my_interest(self, genders):
            self.interests = genders
            self.stage = "my distance"
        def set_distance(self):
            self.stage = "playing"

        def set_more_info(self, date = True):
            if date:
                self.more_info = self.current
            else:
                self.more_info = None
        def view_image(self, image):
            self.image_view = image




screen linger_screen():
    default g = linger_class(
        [
            linger_contact("Emily", "Farm grown and farm loving.", ["emily_linger_1", "emily_linger_2", "emily_linger_3", "emily_linger_4"]),
            linger_contact("Jessica", "Single mom, my son is my world, you have to be a good father to my son, I don't have time for nonsense.", ["jessica_linger_1"]),
            linger_contact("Bethany K Murry", "Super model looking for super rich.", ["bethany_linger_1", "bethany_linger_2", "bethany_linger_3"]),
            linger_contact("Rei Rei", "N/A", ["reirei_linger_1"]),
            linger_contact("Pain magnet", "Don't swipe.", ["pain_1"]),
            linger_contact("Sierra", "#HealthyAtAnySize #SheThem #BodyPositivity #BeautyFull #Princess.", ["sierra_1"]),
            linger_contact("Penny", "The last of terran wood elves. Level 5.", ["penny_1"]),
            linger_contact("Krash", "Got a bike? Swipe right.", ["krash_1"]),
            linger_contact("Tyler", "Footbal and camping, in that order.", ["tyler_1"]),
            linger_contact("Sydney", "Need a builder, body and stuff.", ["sydney_1"]),
            linger_contact("Ava", "Fun!", ["ava_1"]),
            linger_contact("Becky", "Healthy body, healthy mind.", ["becky_1"]),
            linger_contact("Vivian", "Let's see what this is all about.", ["vivian_1"]),
            linger_contact("Isabella", "Stop it, I won't say it.", ["isabella_1"]),
            linger_contact("Hannah", "From the montains.", ["hannah_1"]),
            linger_contact("Madison", "Yall need to calm down, I'm not going anywhere.", ["madison_1"]),
            linger_contact("Luna", "I have games and anime.", ["luna_1"]),
            linger_contact("Sophia", "Must live in NY, no tourists.", ["sophia_1"]),
            linger_contact("Charlotte", "Rock roll and tatoos.", ["charlotte_1"]),
            linger_contact("Anna", "I'm ready to settle down, again.", ["anna_1"]),
            linger_contact("Mai", "We can walk, we can talk, or we can run.", ["mai_1"]),
            linger_contact("Elizabeth", "...", ["elizabeth_1"]),
        ]
        )
    style_prefix "linger"
    frame:
        xysize 500,850 padding 0,0
        background "linger_bg"

        if g.stage == "start":
            frame:
                xfill True
                vbox:
                    text "Welcome to Linger. Your first and only option for dating."
                    button:
                        text "Set me up!"
                        action Function(g.change_stage, "my gender")
        elif g.stage == "my gender":
            frame:
                xfill True
                vbox:
                    text "I'm a..."
                    button:
                        text "Man"
                        action Function(g.set_my_gender, "Man")
                    button:
                        text "Woman"
                        action Function(g.set_my_gender, "Woman")
        elif g.stage == "my interest":
            frame:
                xfill True
                vbox:
                    text "Interested in"
                    button:
                        text "Man"
                        action Function(g.set_my_interest, "Man")
                    button:
                        text "Woman"
                        action Function(g.set_my_interest, "Woman")
                    button:
                        text "Both"
                        action Function(g.set_my_interest, "Both")
        elif g.stage == "my distance":
            frame:
                xfill True
                vbox:
                    text "Search distance."
                    button:
                        text "Not implemented yet"
                        action Function(g.set_distance)
        elif g.stage == "no dates":
            frame:
                xfill True
                vbox:
                    text "There are no more matches."
                    button:
                        text "Change settings"
                        action Function(g.change_stage, "my gender")

        elif g.stage == "playing":
            timer 1 repeat True action Function(g.pick)
            frame:
                padding 0,0 xysize 500,750 yalign 1.0 background None
                if g.current:
                    frame:
                        padding 0,0
                        at linger_alpha
                        add g.current.images[0] at linger_zoom(image_fit(g.current.images[0], 500, 750))
                    frame:
                        yalign 0.0 yoffset 10
                        at linger_alpha
                        text g.current.name
                    hbox:
                        yalign 1.0 yoffset -10
                        at linger_alpha
                        button:
                            text "Pass"
                            action Function(g.dislike)
                        button:
                            text "Like"
                            action Function(g.like)
                        button:
                            text "More info"
                            action Function(g.set_more_info)

        if g.more_info:
            frame:
                padding 0,0 xysize 500,750 yalign 1.0 background "#444"
                vbox:
                    spacing 10
                    text g.more_info.name size 34
                    text g.more_info.info
                    hbox:
                        for i in g.more_info.images:
                            button:
                                padding 10,10
                                add i at linger_zoom(image_fit(g.current.images[0], 100, 100))
                                action Function(g.view_image, i)
                button:
                    yalign 1.0 yoffset -10
                    text "Close"
                    action Function(g.set_more_info, False)
        if g.image_view:
            button:
                padding 0,0 xysize 500,750 yalign 1.0 background "#444"
                add g.image_view at linger_zoom(image_fit(g.image_view, 500, 750)) align .5,.5
                action Function(g.view_image, None)


        frame:
            xfill True ysize 100 background "#b0357dcd" yalign 0.0
            vbox:
                text "Linger"
                text "Your only choice for dating." size 20





transform linger_zoom(z):
    zoom z
transform linger_alpha:
    alpha 0
    ease .2 alpha 1
style linger_frame:
    background "#b0357dcd"
    padding (20,20)
    align (.5,.5)
style linger_button:
    background "#b0357dcd"
    padding (20,20)
    align (.5,.5)
style linger_text:
    align (.5,.5)
    size 24
style linger_vbox:
    align (.5,.5)
    spacing 10
style linger_hbox:
    align (.5,.5)
    spacing 10




label linger_test:
    show bg park with dissolve
    call screen phone_screen(phone_class("linger_screen", ("")))
    "[_return]"

